/*
simple code experiments with hacking the asuro robot
the BackLed routine is copy pasted from the asuro lib
enjoy!
jacob remin
*/

int rforward = 13;
int rreverse = 12;
int lforward = 5;
int lreverse = 4;
int lmotorspeed = 255;
int lmotor= 9;
int rmotorspeed = 255;
int rmotor= 10;
int statusledred = 2;
int frontled = 6;
int lphotores = 3;
int rphotores = 2;
int statusledgreen = 8;
int odometricled = 7;

void setup()
{
  Serial.begin(9600);
  pinMode(rforward, OUTPUT);
  pinMode(rreverse, OUTPUT);
  pinMode(lforward, OUTPUT);
  pinMode(lreverse, OUTPUT);
  pinMode(frontled, OUTPUT);
  pinMode(statusledred, OUTPUT);
  pinMode(statusledgreen, OUTPUT);
  pinMode(odometricled, OUTPUT);

  // fix analog-to-digital converter timing (for 8 MHz clock)
  ADCSRA &= ~ADPS0;
}

void loop()
{
  /* front switch check
  Serial.println("switches pressed");
  Serial.println(readSwitches(), BIN);
  digitalWrite(statusledgreen, HIGH);
  delay(1000);
  */
  
  //front LED on
  digitalWrite(frontled, HIGH);

  /* reading the photoresistors
  Serial. println("left photoresistor");
  Serial.println(analogRead (lphotores));
  Serial. println("right photoresistor");
  Serial.println(analogRead (rphotores));
  */

  /* status LED lightshow
  digitalWrite(statusledred, HIGH);
  delay(200);
  digitalWrite(statusledgreen, HIGH);
  delay(200);
  digitalWrite(statusledred, LOW);
  delay(200);
  digitalWrite(statusledgreen, LOW);  
  */
  
  /* odometric LED  
  digitalWrite(odometricled, HIGH);
  Serial. println("left odometric");
  Serial.println(analogRead (0));
  Serial. println("right odometric");
  Serial.println(analogRead (1));
  */
  
  /*taillights (routine copypasted from asuro lib)
  BackLED (1,1);
  delay(50);
  BackLED (0,1);
  delay(50);
  BackLED (1,0);
  delay(50);
  BackLED (1,1);
  */
  
  //test motion patterns
  //Circular1 (255);

  /*
  int var = 0;
  while (var < 10){
    Square1 (100,255);
    var++;
  }
  */
  
  
  //backwards and fowards test engines
  analogWrite(lmotor, 255);
  analogWrite(rmotor, 255);
  //forwards
  Motordirection (1, 1);
  delay (500);
  Motordirection (0,0);
  delay (500);  
  analogWrite(lmotor, 0);
  analogWrite(rmotor, 0);
  
}

//taillight LEDs
void BackLED(unsigned char left, unsigned char right)
{
	if (left || right) {
		PORTD &= ~(1 << PD7); // Wheel LED OFF
		DDRC |= (1 << PC0) | (1 << PC1); // Output => no odometrie
		PORTC |= (1 << PC0) | (1 << PC1);
	}
	if (!left) PORTC &= ~(1 << PC1);
	if (!right) PORTC &= ~(1 << PC0);
}

//"square" motion pattern
void Square1(int size, int speed){
  analogWrite(lmotor, speed);
  analogWrite(rmotor, speed);
  //forwards
  Motordirection (1, 1);
  delay (size);
  //right
  Motordirection (1,0);    
  delay (size);
  //backwards
  Motordirection (0, 0);
  delay (size);
  //left
  Motordirection (0,1);
  delay (size);
  analogWrite(lmotor, 0);
  analogWrite(rmotor, 0);  
}

//circular accelerating motion pattern
void Circular1(int lenght){
  int var = 0;
  while(var < lenght){
    //left motor forwards
    digitalWrite (4, LOW);
    digitalWrite (5, HIGH);
    //right motor backwards
    digitalWrite (12, HIGH);
    digitalWrite (13, LOW);
    lmotorspeed = var;
    rmotorspeed = var;
    analogWrite(9, lmotorspeed);
    analogWrite(10, rmotorspeed);
    delay(25);
    var++;
  }
}    

//read front switches
int readSwitches()
{
  long tmp;
  pinMode(3, OUTPUT);
  digitalWrite(3, HIGH);
  tmp = analogRead(4);
  digitalWrite(3, LOW);
  return ((10240000L/tmp-10000L)*61L+5000L)/10000;
}

//motordirection
void Motordirection (int left, int right){
  if (left == 1) {
    //left motor forwards
    digitalWrite (4, LOW);
    digitalWrite (5, HIGH);
  }
  else {
    //left motor backwards
    digitalWrite (4, HIGH);
    digitalWrite (5, LOW);
  }
  if (right == 1) {
    //right motor forwards
    digitalWrite (12, LOW);
    digitalWrite (13, HIGH);
  }
  else {
    //right motor backwards
    digitalWrite (12, HIGH);
    digitalWrite (13, LOW);
  }
}  
 
